#ifndef DISTANCE_H
#define DISTANCE_H

#define OVERSAMPLE	16
#define AUTOTRIGGER	//eliminates overhead and clock jitter, cycle time will be 128us

#if  F_CPU == 7372800
#define ADCCLK	6; //div by 64
#elif F_CPU == 14745600
#define ADCCLK	7; //div by 128
#else
#error "define divider for cpu freq "  F_CPU
#endif

#ifdef AUTOTRIGGER
#define DISTANCE_FLAGS	_BV(ADATE)|_BV(ADEN)|ADCCLK
#else
#define DISTANCE_FLAGS			   _BV(ADEN)|ADCCLK
#endif

#ifdef USE_DISTANCE
#define MASK_DISTANCE_INT()		ADCSRA = DISTANCE_FLAGS; 
#define UNMASK_DISTANCE_INT()	ADCSRA = _BV(ADIF)|DISTANCE_FLAGS; 
#else
#define MASK_DISTANCE_INT()		;
#define UNMASK_DISTANCE_INT()	;
#endif

//extern word AD1_OutV[4];
void init_distance();
unsigned get_distance(char i);
void store_distance(unsigned char n, int p[3]);
extern char raw_distance;

#endif
