#ifndef STEPPER_H
#define STEPPER_H

//#define MCP23017	//dumb I2C slave and intelligent control
//#define AVR_STEPPER	//intelligent I2C slave
#define AMIS30624	//onsemi stepper controller

typedef struct
{//common members 
  int dest, pos;//desired pos, actual pos
  int speed;	  //desired speed 
  unsigned starts, motor_pos_reached, ack_reset, resets; //reserved, motor_pos_reached, unknown, cnt_reset from TA
  char master;
//specific to direct coil control
  int count;		//delay counter
  char mode;         //step mode (full, half, wave)
//specific to AMIS control
  char flags;		//changes in settings
  enum {idle, setparam, resetpos, setpos, stop, status, speed, status1, initmot} state;
  char esw;
//for bresenham
  int delta, eps;//eps is slave only
  union
  { char steep; //slave only
    char m_rdy; //master only
  };
  signed char step;
} stepper_desc;

#ifdef MCP23017
#define STEPPER_TIME	10	//1ms
#endif

#ifdef AVR_STEPPER
#define STEPPER_TIME	100	//10ms
#endif

#ifdef AMIS30624
#define STEPPER_TIME	100	//10ms
void poll_stepper();
void set_stepper_pars(char n, char p[]);
#endif

void update_steppers();
void init_steppers();
//void set_stepper(int i, unsigned dest, int speed, int reset, unsigned reserved);
void set_stepper(TA_OUTPUT *out);

extern stepper_desc steppers[];
extern char statbuf[];//publish for debug only
#endif
